import QtQuick 2.8
import QtQuick.Layouts 1.1
import org.kde.plasma.plasmoid 2.0
import org.kde.plasma.core 2.0 as PlasmaCore

Item {
    id: compactRepresentation

    anchors.fill: parent

    CompactItem {
        id: compactItem
        inTray: false
    }

    MouseArea {
        anchors.fill: parent
        acceptedButtons: Qt.LeftButton | Qt.MiddleButton
        hoverEnabled: true
        onClicked: {
            if (mouse.button == Qt.MiddleButton) {
                main.refresh()
            } else {
                plasmoid.expanded = !plasmoid.expanded
            }
        }

        PlasmaCore.ToolTipArea {
            id: toolTipArea
            anchors.fill: parent
            active: !plasmoid.expanded
            interactive: true
            mainText:Math.round(wData.weather.currently.temperature)+"° "+"   "+wData.weather.currently.summary
            subText: wData.warnings ? "⚠  "+wData.weather.alerts[0].title : wData.weather.hourly.summary
            //textFormat: Text.RichText
            icon: wData.weather.currently.icon//Qt.resolvedUrl('../images/wData.weather-widget.svg')
            //icon:wData.warnings ? "weather-severe-alert-symbolic" : wData.weather.currently.icon
        }
    }
}
