import QtQuick 2.9
import QtQuick.Layouts 1.15
import org.kde.plasma.core 2.1
import QtGraphicalEffects 1.15

Item {
    id: fullRepresentation
    width: 470
    implicitHeight: viewHeight// wData.warnings ? 515 :  viewHeight
    //height:540
    property var viewHeight:parseInt(iconCode.height+summary.height+story.height+forecast.height+radar.height)
    //WeatherData{id:wData}

    //Component.onCompleted: {
       // fullRepresentation.height=parseInt(iconCode.height+temp.height+summary.height+story.height+ts.height+forecast.height+ts1.height+radar.height)* units.devicePixelRatio
   // }

    Text {
        id:lastUpdate
        text:"Last update: "+ wData.last_update//+"\n"+story.text.length
        color:"gray"
        antialiasing : true
        font.pointSize:10
        anchors.top:fullRepresentation.top
        anchors.right:fullRepresentation.right


        MouseArea {
            id: updatemouseArea
            anchors.fill: parent
            cursorShape: Qt.PointingHandCursor
            hoverEnabled:true
            onEntered: lastUpdate.color=Theme.viewHoverColor
            onExited:lastUpdate.color=Theme.viewTextColor
            onClicked: {
                wData.getWeather(wData.url2)
                wData.radarImage="";
                wData.radarImage="https://cdns.abclocal.go.com/three/ktrk/weather/16_9/SETX1_1280.jpg";
                wData.updateWeatherTimer.restart()
            }
        }
    }
    Row {
        id:conditions
        anchors.top:fullRepresentation.top
        anchors.left:fullRepresentation.left
        spacing:10

        Image {
            id:iconCode
            source:"../icons/"+wData.weather.currently.icon+".png"
            width:64
            height:64
            smooth:true
            anchors.topMargin:10
            anchors.top:conditions.top
        }

        Text {
            id:temp
            anchors.top:iconCode.top
            anchors.topMargin:10
            text:"  "+Math.round(wData.weather.currently.temperature)+"° "
            color:Theme.viewTextColor
            font.pointSize:24
            antialiasing : true
        }

        Text {
            id:summary
            anchors.bottom:temp.bottom
            //anchors.topMargin:30
            text:wData.warnings ? wData.alert_text : wData.weather.currently.summary
             // if wData.weather alert show that instead of summary
            color:Theme.viewTextColor
            font.pointSize:16
            antialiasing : true

            MouseArea {
            id: mouseArea
            anchors.fill: parent
            cursorShape: wData.warnings ? Qt.PointingHandCursor : Qt.ArrowCursor
            hoverEnabled: wData.warnings ? true : false
            onEntered:wData.warnings ? summary.color=Theme.viewHoverColor: summary.color=Theme.viewTextColor
            onExited:wData.warnings ? summary.color=Theme.viewTextColor : summary.color=Theme.viewTextColor
            onClicked: {
                Qt.openUrlExternally(wData.weather.alerts[0].uri)
            }
        }
        }
    }

    Text {
        id:story
        anchors.top:conditions.bottom
        anchors.left:conditions.left
        anchors.leftMargin:70
        anchors.topMargin:10
        text:wData.weather.hourly.summary+"<br> Real Feel: "+ Math.round(wData.weather.currently.apparentTemperature)+"° "+ " Humidity: "+Math.round((wData.weather.currently.humidity)*100)+"% "+" Wind: "+wData.degToCompass(wData.weather.currently.windBearing)+" at "+Math.round(wData.weather.currently.windSpeed)+"mph"//+" Gusts at "+Math.round(wData.weather.currently.windGust)+" mph"
        wrapMode:Text.WordWrap
        textFormat: Text.RichText
        Layout.fillWidth : true
        width:405
        color:Theme.viewTextColor
        //font.pointSize:14
        //font.pointSize:wData.warnings ? 14:13
        font.pointSize:story.text.length > 110 ? 12 : 13.6
        antialiasing : true
    }

    Rectangle {
        id:ts
        anchors.top:story.bottom
        anchors.topMargin:10
        implicitWidth: fullRepresentation.width
        implicitHeight: 1
        color: "gray"
        antialiasing : true
        Layout.fillWidth: true
    }

    Column {
        id:forecast
        anchors.top:ts.bottom
        topPadding:10
        Row {
            spacing:37
            leftPadding:30;
            Repeater {
                model: 5
                Text {
                    text:Qt.formatDate(new Date(wData.weather.daily.data[index].time*1000)," ddd ")
                    color:Theme.viewTextColor
                    font.pointSize:14
                    antialiasing : true
                    width:55
                    Layout.fillWidth: true
                }
            }
        }
        Row {
            id:icons
            spacing:45;
            leftPadding:25;

            Repeater {
                model: 5
                Image {
                    source:"../icons/"+wData.weather.daily.data[index].icon+".png"
                    width:48
                    height:48
                    smooth:true
                }
            }
        }

        Row {
            spacing:1.25
            leftPadding:40
            Repeater {
                model: 5
                Text {
                    text:Math.round(wData.weather.daily.data[index].precipProbability*100/10)*10+"% "
                    //text:(rainChances[index]*100/10)*10+"% "
                    color:Theme.viewTextColor
                    width:(Math.round(wData.weather.daily.data[index].precipProbability*100/10)*10 > 9) ? 92:95
                    //width:((rainChances[index]*100/10)*10 < 10) ? 89:91
                    Layout.fillWidth:true
                    font.pointSize:12
                    antialiasing : true
                }
            }
        }

        Row {
            id:temps
            spacing:29;leftPadding:20
            Repeater {
                model: 5
                Text {
                    text:Math.round(wData.weather.daily.data[index].temperatureLow)+"° | "+Math.round(wData.weather.daily.data[index].temperatureHigh)+"°"
                    color:Theme.viewTextColor
                    font.pointSize:12
                    antialiasing : true
                    width:64
                    Layout.fillWidth:true
                }
            }
        }
    }

        Rectangle {
            id:ts1
            anchors.top:forecast.bottom
            anchors.topMargin:5
            implicitWidth: fullRepresentation.width
            implicitHeight: 1
            color: "gray"
            antialiasing : true
            Layout.fillWidth: true
        }
        Column {
            id:radar_info
            anchors.top:ts1.bottom
            anchors.topMargin:5
            anchors.left:fullRepresentation.left
            spacing:2
            Text {text:" ";font.pointSize:2}  //spacer
            Image {
                id:radar
                source:wData.radarImage
                smooth: false // allow opacity mask == false
                width: fullRepresentation.width
                fillMode:Image.PreserveAspectFit
                visible: false
            }

                MouseArea {
                    anchors.fill: radar
                    acceptedButtons: Qt.LeftButton | Qt.MiddleButton
                    hoverEnabled: true
                    cursorShape:Qt.PointingHandCursor
                    onClicked: {
                        Qt.openUrlExternally("https://abc13.com/weather/")
                    }
                }

                OpacityMask {
                    anchors.fill: radar
                    source: radar
                    maskSource: Rectangle {
                        width: radar.width
                        height: radar.height
                        radius: 8
                        antialiasing : true
                        visible: false // this also needs to be invisible or it will cover up the image
                    }
                }
            }
    }
